Package javassist.util.proxy

# Class RuntimeSupport

java.lang.Object
javassist.util.proxy.RuntimeSupport

public class RuntimeSupport extends Object
Runtime support routines that the classes generated by ProxyFactory use.

See Also:
  - `ProxyFactory`

## Field Summary

Fields
Modifier and Type
Field
Description
`static MethodHandler`
`default_interceptor`
A method handler that only executes a method.

## Constructor Summary

Constructors
Constructor
Description
`RuntimeSupport()`

## Method Summary

Modifier and Type
Method
Description
`static void`
`find2Methods(Class<?> clazz, String superMethod, String thisMethod, int index, String desc, Method[] methods)`
Finds two methods specified by the parameters and stores them into the given array.
`static void`
`find2Methods(Object self, String superMethod, String thisMethod, int index, String desc, Method[] methods)`
Deprecated.
replaced by `find2Methods(Class, String, String, int, String, Method[])`
`static Method`
`findMethod(Class<?> clazz, String name, String desc)`
Finds a method with the given name and descriptor.
`static Method`
`findMethod(Object self, String name, String desc)`
Deprecated.
replaced by `findMethod(Class, String, String)`
`static Method`
`findSuperClassMethod(Class<?> clazz, String name, String desc)`
Finds a method that has the given name and descriptor and is declared in the super class.
`static Method`
`findSuperMethod(Object self, String name, String desc)`
Finds a method that has the given name and descriptor and is declared in the super class.
`static String`
`makeDescriptor(Class<?>[] params, Class<?> retType)`
Makes a descriptor for a given method.
`static String`
`makeDescriptor(Method m)`
Makes a descriptor for a given method.
`static String`
`makeDescriptor(String params, Class<?> retType)`
Makes a descriptor for a given method.
`static javassist.util.proxy.SerializedProxy`
`makeSerializedProxy(Object proxy)`
Converts a proxy object to an object that is writable to an object stream.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### default_interceptor

public static MethodHandler default_interceptor
A method handler that only executes a method.

## Constructor Details

### RuntimeSupport

public RuntimeSupport()

## Method Details

### find2Methods

public static void find2Methods(Class<?> clazz, String superMethod, String thisMethod, int index, String desc, Method[] methods)
Finds two methods specified by the parameters and stores them into the given array.

Throws:
  `RuntimeException` - if the methods are not found.
See Also:
  - `ProxyFactory`

### find2Methods

@Deprecated public static void find2Methods(Object self, String superMethod, String thisMethod, int index, String desc, Method[] methods)
Deprecated.
replaced by `find2Methods(Class, String, String, int, String, Method[])`
Finds two methods specified by the parameters and stores them into the given array.

Added back for JBoss Seam. See JASSIST-206.

Throws:
  `RuntimeException` - if the methods are not found.
See Also:
  - `ProxyFactory`

### findMethod

@Deprecated public static Method findMethod(Object self, String name, String desc)
Deprecated.
replaced by `findMethod(Class, String, String)`
Finds a method with the given name and descriptor. It searches only the class of self.

Added back for JBoss Seam. See JASSIST-206.

Throws:
  `RuntimeException` - if the method is not found.

### findMethod

public static Method findMethod(Class<?> clazz, String name, String desc)
Finds a method with the given name and descriptor. It searches only the class of self.

Throws:
  `RuntimeException` - if the method is not found.

### findSuperMethod

public static Method findSuperMethod(Object self, String name, String desc)
Finds a method that has the given name and descriptor and is declared in the super class.

Throws:
  `RuntimeException` - if the method is not found.

### findSuperClassMethod

public static Method findSuperClassMethod(Class<?> clazz, String name, String desc)
Finds a method that has the given name and descriptor and is declared in the super class.

Throws:
  `RuntimeException` - if the method is not found.

### makeDescriptor

public static String makeDescriptor(Method m)
Makes a descriptor for a given method.

### makeDescriptor

public static String makeDescriptor(Class<?>[] params, Class<?> retType)
Makes a descriptor for a given method.

Parameters:
  `params` - parameter types.
  `retType` - return type.

### makeDescriptor

public static String makeDescriptor(String params, Class<?> retType)
Makes a descriptor for a given method.

Parameters:
  `params` - the descriptor of parameter types.
  `retType` - return type.

### makeSerializedProxy

public static javassist.util.proxy.SerializedProxy makeSerializedProxy(Object proxy) throws InvalidClassException
Converts a proxy object to an object that is writable to an object stream. This method is called by `writeReplace()` in a proxy class.

Throws:
  `InvalidClassException`
Since:
  3.4